locals

if FUNC_L     ; 16-bit (Large memory model) version
_TEXT segment dword public use16 'CODE'
else
_TEXT segment dword public use32 'CODE'
endif
    assume cs:_TEXT
    public @swap16
    public @swap32


; Bit32 _fastcall swap32( Bit32 value )
;    gets argument in EAX or DX+AX registers and returns result in same
;

if FUNC_L
@swap32 proc far  ; Large model, param in dx+ax
    xchg  ax,dx
    xchg  al,ah
    xchg  dl,dh
else

@swap32 proc near  ; Flat model, param in EAX
if @Cpu AND 32
    bswap eax      ; Pentium instructions enabled
else
    xchg  al,ah    ; Use 386 instructions
    ror   eax,16
    xchg  al,ah
endif

endif
    ret
@swap32 endp


; Bit16 _fastcall swap16( Bit16 value )
;    gets argument in AX register and returns result in same
;
if FUNC_L
@swap16 proc far
else
@swap16 proc near
endif

    xchg ah,al
    ret
@swap16 endp


_TEXT ends

end
