#include "..\wattcp\copyrigh.h"
#include <stdio.h>
#include "..\wattcp\wattcp.h"
#include <stdlib.h>    /* itoa */
#include <string.h>
#include "..\wattcp\elib.h"

/*
 * PCBSD - provide some typical BSD UNIX functionality
 * Erick Engelke, Feb 22, 1991
 */

/*
 * chk_socket - determine whether a real socket or not
 *
 */
_chk_socket( tcp_Socket *s )
{
    if ( s->ip_type == IPPROTO_TCP ) {
        if ( s->state <= tcp_StateCLOSED)       /* skips invalid data */
            return( 2 );
    }
    if ( s->ip_type == IPPROTO_UDP ) return( 1 );
    return( 0 );
}

char *sockerr( tcp_Socket *s )
{
    if ( strlen( s->err_msg ) < 80 )
        return( s->err_msg );
    return( NULL );
}

static char *sock_states[] = {
    "Listen","SynSent","SynRec","Established","FinWt1","FinWt2","ClosWt","LastAck"
    "TmWt","Closed"};

char *sockstate( tcp_Socket *s )
{
    switch ( _chk_socket( s )) {
       case  1 : return( "UDP Socket" );
       case  2 : return( sock_states[ s->state ] );
       default : return( "Not an active socket");
    }
}
longword gethostid()
{
    return( my_ip_addr );
}

longword sethostid( longword ip )
{
    return( my_ip_addr = ip );
}
