.386p
locals


_DATA segment dword public 'DATA' use32
    assume cs:_DATA

dummy   proc near

@@startThunk        label byte

    PUBLIC  _interrupt32Thunk
_interrupt32Thunk  label byte

    ; save the foreground routine's registers
    ; except for SS:ESP, CS:EIP and EFLAGS
    ;
    push eax
    push ebx
    push ecx
    push edx
    push es
    push ds
    push esi
    push edi
    push ebp

    mov ax, 01234h

    PUBLIC  __I32TdsLoadLabel
__I32TdsLoadLabel   EQU $ - @@startThunk - 2

    mov ds, ax

    ; opcode for a call to an absolute 32-bit address w/o segment
    ;
    db  0e8h
    dd  0

    PUBLIC  __I32TcallLabel
__I32TcallLabel     EQU $ - @@startThunk - 4

    ; restore the foreground routine's registers
    ;
    pop ebp
    pop edi
    pop esi
    pop ds
    pop es
    pop edx
    pop ecx
    pop ebx

    cmp eax, 0
    jne @@chain
@@iret:
    pop eax
    iret

@@chain:
    pop eax
    jmp fword ptr cs:[012345678h]

    PUBLIC  __I32TchainLabel
__I32TchainLabel    EQU $ - @@startThunk - 4

    PUBLIC  __interrupt32ThunkSize
__interrupt32ThunkSize  EQU $ - @@startThunk

dummy   endp

_DATA ends

end

